<?php
////////////////////////////////////////////////////////////////////////////////
//   Copyright (C) Hakkah ~ CMS Development Team                              //
//   http://hakkahcms.org                                                     //
//                                                                            //
//   This program is distributed in the hope that it will be useful,          //
//   but WITHOUT ANY WARRANTY, without even the implied warranty of           //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     //
//                                                                            //
//   This product released under GNU General Public License v2                //
////////////////////////////////////////////////////////////////////////////////

/**
 * Debug on/off
 *
 */
define("DEBUG",0);
$query_counter=0;

/**
 * MySQL database working class
 *
 */
class MySQLDB
{
	var $connection;
	var $last_query_num = 0;
	var $db_config = array();
	
	/**
	 * last query result id
	 *
	 * @var MySQL result
	 */
	 var $lastresult;
	/**
	 * last query assoc value
	 *
	 * @var bool
	 */
	 var $assoc = true;
	
	/**
	 * Initialises connection with MySQL database server and selects needed db
	 *
	 * @param MySQL Connection Id $connection
	 * @return MySQLDB
	 */
	function MySQLDB($connection=false)
	{
		if($connection)
			$this->connection=$connection;
		else
		{
			if(!($this->db_config = @parse_ini_file('config/'.'mysql.ini')))
			{
				print(('Cannot load mysql configuration'));
				return false;
			}

			if(!extension_loaded('mysql'))
			{
				print(('Unable to load module for database server "mysql": PHP mysql extension not available!'));
				return false;
			}

			$this->connection = @mysql_connect($this->db_config['server'], $this->db_config['username'], $this->db_config['password']);
		}

		if(empty($this->connection))
		{
			print(('Unable to connect to database server!'));
			return false;
		}
		else if(!@mysql_select_db($this->db_config['db'], $this->connection))
		{
			$this->db_error();
			return false;
		}
		
		mysql_query ("set character_set_client='cp1251'"); 
		mysql_query ("set character_set_results='cp1251'"); 
		mysql_query ("set collation_connection='cp1251_general_ci'");
		
		return true;
	}
	
	/**
	 * Executes query and returns result identifier
	 *
	 * @param string $query
	 * @return MySQL result
	 */
	 function query($query) 
	{
		// use escape/vf function for input data.
		//print('<textarea rows="5" cols="70">'.$query.'</textarea><br>');
		$result = @mysql_query($query, $this->connection) or $this->db_error(0, $query);
		$this->last_query_num++;
		return $result;
	}
	
	//      mysqlcommand (MySQL Connector 4 .NET):)
	/**
	 * Executes query and makes abstract data read available
	 *
	 * @param string $query
	 * @param bool $assoc
	 */
	function ExecuteReader($query,$assoc = true)
	{
		$this->lastresult = $this->query($query);
		$this->assoc=$assoc;		
	}
	
	/**
	 * Link to query method
	 *
	 * @param string $query
	 * @return MySQL result
	 */
	function ExecuteNonQuery($query)
	{
		$result = $this->query($query);
		return (mysql_affected_rows()==0 ? false : $result);	
	}
	
	/**
	 * Returns array with from the current query result
	 *
	 * @return array
	 */
	function Read()
	{
		if($this->assoc)
		{
			$result = @mysql_fetch_assoc($this->lastresult) or false;
		}
		else
		{
			$result = @mysql_fetch_row($this->lastresult) or false;
		}
		return $result;
	}
	
	
	/**
	 * Returns one row from the current query result
	 *
	 * @param int $row
	 * @return string
	 */
	function ReadSingleRow($row)
	{
		return mysql_result($this->lastresult,$row) or false;
	}

	/**
 	* Prints MySQL error message; swithing DEBUG, prints MySQL error description or sends it to administrator
 	*
 	*/
	function db_error($show=0,$query='')
	{
		global $system;
		if(!in_array(mysql_errno(),array(1062,1065,1191))) // Errcodes in array are handled at another way :)
		{
			if(DEBUG==1 || $show==1)
			{
				$warning='<br><b>'.('MySQL Error').':</b><br><i>';
				$warning.=mysql_errno().' : '.mysql_error().(empty($query) ? '</i>' : '<br>In query: <textarea cols="50" rows="7">'.$query.'</textarea></i>');
				print($warning) or print($warning);
			}
			else
			{
				print('An error occured. Please, try again later. Thank You !');
				$message.=mysql_errno().':'.mysql_error()."\r\n";
				$message.=(empty($query) ? '' : "In query: \r\n".$query."\r\n");
				rcms_log_put('MySQL error',$system->user['username'],$message);
			}
		}
	}
	
	/**
	 * Escapes string to use in SQL query
	 *
	 * @param string $string
	 * @return string
	 */
	function escape($string)
	{
		if (!get_magic_quotes_gpc()) 
	    	return mysql_real_escape_string($string,$this->connection);
		else
    		return mysql_real_escape_string(stripslashes($string),$this->connection);
	}
	
	/**
	 * Disconnects from database server
	 *
	 */
	function disconnect() 
	{
		@mysql_close($this->connection);
	}
}

/**
 * Returns cutted down entry data
 *
 * @param string $data
 * @param int $mode
 * @return string
 */
function vf($data,$mode=0)
{
	switch ($mode)
	{
		case 1:
			return ereg_replace("[^a-z0-9A-Z]",'',$data); // , 
			break;
		case 2:
			return ereg_replace("[^a-zA-Z]",'',$data); // 
			break;
		case 3:
			return ereg_replace("[^0-9]",'',$data); // 
			break;
		case 4:
			return ereg_replace("[^a-z0-9A-Z\-_\.]",'',$data); // , , , , 
			break;
		case 5:
			return ereg_replace("[^ [:punct:]".('a-zA-Z')."0-9]",'',$data); // .    +    
			break;
		default:
			return ereg_replace("[~@\+\?\%\/\;=\*\>\<\"\'\-]",'',$data); // -   .
			break;
	}
}



// function that executing query and returns array
function simple_queryall($query) {
global $query_counter;
	if (DEBUG) {
	print ($query."\n");
}
$result='';
$queried = mysql_query($query) or die('wrong data input [sqa]');
while($row = mysql_fetch_assoc($queried)) {
 $result[]=  $row;
}
$query_counter++;
return($result);
}

// function that executing query and returns array of first result
function simple_query($query) {
global $query_counter;
	if (DEBUG) {
	print ($query."<br />\n");
}
$queried = mysql_query($query) or die('wrong data input [sq]');
$result= mysql_fetch_assoc($queried);
$query_counter++;
return($result);
}



// function that just executing query 
function nr_query($query) {
global $query_counter;
if (DEBUG) {
	print ($query."\n");
}
$queried = mysql_query($query) or die('wrong data input [nrq]');
$query_counter++;
return($queried);
}



?>